function [this, vals] = pop( this )

% [this, vals] = pop( this )


%  This file is a part of the Independent Variable Group Analysis package
% 
%  Copyright (C) 2001-2006 Esa Alhoniemi, Antti Honkela, Krista Lagus,
%  Jeremias Seppa, Harri Valpola, and Paul Wagner
% 
%  This program is free software; you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation; either version 2, or (at your option)
%  any later version.
% 
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License (included in file License.txt in the
%  program package) for more details.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


if ~this.enabled
  vals = this.nan_vals;
else
  
  for i=1:this.ninputs
    [this.inputs{i}, in{i}] = pop( this.inputs{i} );
  end
  
  if isempty( this.constructor )
    % normal, stateless mode
    vals = eval( this.cmd );
  else
    % stateful mode
    state = this.state;
    eval( this.cmd );
    vals = out;
    this.state = state;
  end
  
  % flush all inputs?
  if all(isnan(vals))
    for i=1:this.ninputs
      out = 0;
      while any(~isnan(out))
        [this.inputs{i}, out] = pop( this.inputs{i} );
      end
    end
  end
  
end

return;
