function object = trigger_iters( iters, input )

% object = trigger_iters( iters, input )
%
% Triggers when specified number of values are read from the given input.
% (if the input has multiple channels, then their input count is summed)
%
% WARNING: if using flt_stats_reader as input at iteration level, then it
%          should be kept in mind that the measure('start') call also
%          inserts a row into the iteration results! It is recommended to
%          used flt_stats_reader in iteration counter mode with this filter
%          (in that mode it ignores the extra iteration).


%  This file is a part of the Independent Variable Group Analysis package
% 
%  Copyright (C) 2001-2006 Esa Alhoniemi, Antti Honkela, Krista Lagus,
%  Jeremias Seppa, Harri Valpola, and Paul Wagner
% 
%  This program is free software; you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation; either version 2, or (at your option)
%  any later version.
% 
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License (included in file License.txt in the
%  program package) for more details.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% define the class so that matlab recognizes it when loading objects
if nargin == 0
  this.enabled     = [];
  this.iters       = [];
  this.max_iters   = [];
  this.input       = [];
  object = class( this, 'trigger_iters' );
  return;
end


this.enabled     = 0;
this.iters       = [];
this.max_iters   = iters;
this.input       = input;


object = class( this, 'trigger_iters' );
return;
